import type { CanvasLike, DataURLOptions } from '@antv/g-lite';
import { CanvasConfig, ContextService } from '@antv/g-lite';
import type * as DeviceRenderer from '@antv/g-plugin-device-renderer';
export declare class WebGLContextService implements ContextService<WebGLRenderingContext> {
    private canvasConfig;
    private deviceRendererPlugin;
    private $container;
    private $canvas;
    private dpr;
    constructor(canvasConfig: CanvasConfig, deviceRendererPlugin: DeviceRenderer.Plugin);
    init(): Promise<void>;
    getDomElement(): CanvasLike;
    getContext(): WebGLRenderingContext | WebGL2RenderingContext;
    getBoundingClientRect(): DOMRect;
    destroy(): void;
    resize(width: number, height: number): void;
    getDPR(): number;
    applyCursorStyle(cursor: string): void;
    toDataURL(options?: Partial<DataURLOptions>): Promise<any>;
}
//# sourceMappingURL=WebGLContextService.d.ts.map